unit Boxes;
// Version 1.7
// added MSG plug for LSSlider
// Version 1.6
// Transparencys Added
// Systray alike Skinning added
// Version 1.04
// Added new way of preventing the Boxes from drifting away
// Version 1.03
// New Binary Flag system
// Version 1.02
// added LsBoxStartHidden
// Version 1.01
// Fixed the dissapearing box problem by ignoring the ParentWnd supplied on InitModuleEx
// cleaned up some code
// Version 1.0

Interface
uses
  Windows,
  BoxFiles,
  Shortcuts,
  Modules,
  LoadModules,
  ModuleHooks,
  WharfModules,
  BoxAPI,
  MyTypes;

function BuildBox(FileName: String;ParentWnd: HWND): PBox;
Procedure DestroyBox(Box: PBox);

Implementation

function WndProc(Wnd, Msg: Integer; wParam, lParam: Longint): Longint; stdcall;
Var
  Box,DBox: PBox;
  DockedBox: PDockedBox;
  p: TPoint;
  lprc: PRECT;
  wp: PWindowPos;

Begin
  WndProc := 0;
  Box := GetBoxFromWnd(First_Box,Wnd);
  Case Msg Of
    WM_MOVING:
     If GetFlag(Box^.Flags,Moveing) Then
      With Box^ do
       begin
        lprc := Pointer(lParam);
        If ( lprc.top<SnapRect.top ) then
          MoveRect(lprc,lprc.left,SnapRect.top)
        else if ( lprc.bottom>SnapRect.bottom ) then
          MoveRect(lprc,lprc.left,SnapRect.bottom-Box^.Height);
        If ( lprc.left<SnapRect.left ) then
          MoveRect(lprc,SnapRect.left,lprc.top)
        else if ( lprc.right>SnapRect.right ) then
          MoveRect(lprc,SnapRect.right-Box^.Width,lprc.top);
        If GetFlag(Box^.Flags,isDocked) then
          InvalidateRgn(Box^.hMainWnd,0,true);
        Box^.xPos := lprc.left;
        Box^.yPos := lprc.top;
        MoveDockedBoxes(Box);
       end;
    BM_MOVEBOX:
      begin
        Box^.xPos := lParam; Box^.yPos := wParam;
        MoveWindow(wnd,Box^.xPos,Box^.yPos ,Box^.Width,Box^.Height,false);
      end;
    WM_ERASEBKGND:
      If NOT GetFlag(Box^.Flags,noBackground) Then
        If (Box^.Stretched) then
            StretchBlt(wParam,0,0,Box^.Width, Box^.Height,Box^.BackDc, 0, 0, Box^.bgWidth, Box^.bgHeight, SRCCOPY)
        else
          BitBlt(wParam,0,0,Box^.Width,Box^.Height,Box^.BackDc,0,0,SRCCOPY)
      else
        WndProc := DefWindowProc(Wnd,msg,wParam,lParam);
    WM_NCHITTEST:
         begin
           p.x := LOWORD(lParam);
           p.y := HIWORD(lParam);
           ScreenToClient(Box^.hMainWnd,p);
           If PtInRegion(Box^.dragRGN,p.x,p.y) then
           begin
             SetFlag(Box^.Flags,Moveing,true);
             WndProc := HTCAPTION;
           end else
               WndProc := HTCLIENT;
         end;
    WM_EXITSIZEMOVE:
      begin
        SetFlag(Box^.Flags,Moveing,false);
        MoveWindow(Wnd,Box^.xPos,Box^.yPos,Box^.Width,Box^.Height,false);
        //MsgBox(0,Box^.Title+Int2Str(Box^.xPos));
      end;
   WM_WINDOWPOSCHANGING:
    If GetFlag(Box^.Flags,HugBottom)then
      begin
        wp := Pointer(lParam);
        wp^.hwndInsertAfter := GetNextWindow(FindWindow('DesktopBackgroundClass','DesktopBackgroundClass'),GW_HWNDPREV);
      end;
    WM_LBUTTONUP:
      If NOT GetFlag(Box^.Flags,Moveing) Then
        PostMessage(Command_HWND,BM_COMMAND,Box^.hMainWnd,Integer(Pchar(Box^.LeftClickBang)));
    WM_RBUTTONUP:
        PostMessage(Command_HWND,BM_COMMAND,Box^.hMainWnd,Integer(Pchar(Box^.RightClickBang)));
    WM_SYSCOMMAND:
      If (wParam = 61536) Then WndProc := 0 Else
        WndProc := DefWindowProc(Wnd,msg,wParam,lParam);
    WM_ACTIVATE:
      begin
       If layerd then
        If GetFlag(Box^.Flags,AlphaTransparent) Then
          If (LOWORD(wParam)=WA_INACTIVE) then
           SetLayeredWindowAttributes(Box^.hMainWnd, RGB($FF,$00,$FF), Box^.InActTrans, LWA_ALPHA or LWA_COLORKEY)
          else SetLayeredWindowAttributes(Box^.hMainWnd, RGB($FF,$00,$FF), Box^.ActTrans, LWA_ALPHA or LWA_COLORKEY);
        If GetFlag(Box^.Flags,AutoHide) Then
          If (LOWORD(wParam)=WA_INACTIVE) then
           begin
             if GetFlag(Box^.Flags,UseFX) then
               AnimateWindow(Box^.hMainWnd,Box^.FXDelay,AW_HIDE or Box^.FX)
             else
               ShowWindow(Box^.hMainWnd,SW_Hide);
             SetFlag(Box^.Flags,Hidden,true);
           end;
      end;
    BM_DOCK:
      begin
        DBox := GetBoxFromWnd(First_Box, wParam);
        if (DBox<>nil) then
         begin
           New(DockedBox);
           DBox.DockedToBox := Box;
           DockedBox.fBox := DBox;
           DockedBox.xOffs := Box.xPos-DBox.xPos;
           DockedBox.yOffs := Box.yPos-DBox.yPos;
           DockedBox.Prev_DockedBox := nil;
           DockedBox.Next_DockedBox := Box.First_DockedBox;
           If (Box.First_DockedBox<>nil) then
             DockedBox.Next_DockedBox.Prev_DockedBox := DockedBox;
           Box.First_DockedBox := DockedBox;
         end;
      end;
    BM_UNDOCK:
      begin
        DBox := GetBoxFromWnd(First_Box, wParam);
        DockedBox := Box.First_DockedBox;
        While (DockedBox<>nil)and(DockedBox.fBox<>DBox) do
          DockedBox := DockedBox.Next_DockedBox;
        If (DockedBox<>nil) then
         begin
           DBox.DockedToBox := nil;
           If (DockedBox.Prev_DockedBox=nil) then
             Box.First_DockedBox := DockedBox.Next_DockedBox
           else
            begin
              DockedBox.Prev_DockedBox.Next_DockedBox := DockedBox.Next_DockedBox;
              DockedBox.Next_DockedBox.Prev_DockedBox := DockedBox.Prev_DockedBox;
            end;
            Dispose (DockedBox)
         end;
      end;
    Else
      WndProc := DefWindowProc(Wnd,msg,wParam,lParam);
  End;
End;

function BuildBox(FileName: String;ParentWnd: HWND): PBox;
Var
  Box: PBox;
  Wc: TWndClass;
  BackBMP: HBitmap;
  p: TPoint;
  Buffer: String;
  TmpBoxPtr: Pointer;
  BackRgn: HRGN;
  tmpRGN: HRGN;
  FXStr: String;
  BoxHeader: PBoxHeader;
Begin
  BuildBox := nil;
  TmpBoxPtr := OpenBox(FileName);

  //If not found try to add the Litestep Path
  If (TmpBoxPtr = Nil) Then
  Begin
     TmpBoxPtr := OpenBox(LsPath+'\'+FileName);
     If (TmpBoxPtr = Nil) Then
     Begin
       MsgBox(MB_ICONWARNING,'Can''t load .Box File:'+#13+FileName);
       Exit;
     End;
  End;

  //Prevent Double-Loading of boxes
  Box := First_Box;
  Buffer := GetBoxString(TmpBoxPtr,'LsBoxName','LsBox');
  while Box<>nil do
   begin
    If (Box^.Title = Buffer) then
     begin
       ShowWindow( Box^.hMainWnd, SW_Show );
       Closebox(TmpBoxPtr,false);
       Exit;
     end;
    Box := Box^.Next_Box;
   end;

  New(Box);
  Box^.Next_Box  := First_Box;
  If (Box^.Next_Box<>nil) then
    Box^.Next_Box^.Prev_Box := Box;
  Box^.Prev_Box := nil;
  First_Box := Box;
  Box^.BoxPtr := TmpBoxPtr;

  With Box^ do
   Begin
     Flags := 0;
     If (ParentWnd=0) then
       FxEnabled := Layerd
     else
       FxEnabled := false;

     Title := GetBoxString(BoxPtr,'LsBoxName','LsBox');

     If GetBoxBool(BoxPtr,'LsBoxPopupAtMousePos') then
     begin
       GetCursorPos(p);
       xPos := p.x; yPos := p.y;
     end else begin
       xPos := Normalize(GetBoxInt(BoxPtr,'LsBoxX',0),ScreenX);
       yPos := Normalize(GetBoxInt(BoxPtr,'LsBoxY',0),ScreenY);
     end;

     buffer := GetBoxString(BoxPtr,'LsBoxSnapArea','nOpE');
     if ( buffer<>'nOpE' ) then
     begin
       SnapRect.Left := Normalize(Str2Int(GetToken(buffer,1)),ScreenX);
       SnapRect.Top  := Normalize(Str2Int(GetToken(buffer,2)),ScreenY);
       SnapRect.Right :=  Normalize(Str2Int(GetToken(buffer,3)),ScreenX);
       SnapRect.Bottom := Normalize(Str2Int(GetToken(buffer,4)),ScreenY);

     end else begin
       SnapRect.top := 0;
       SnapRect.left := 0;
       SnapRect.Bottom := ScreenY;
       SnapRect.Right := ScreenX;
     end;

     BackBMP := LoadLSImage(PChar(GetBoxString(BoxPtr,'LsBoxBackGround','LsBox.bmp')),nil);
     If (BackBMP=0) then
       SetFlag(Box^.Flags, noBackground, true);
       
     GetLSBitmapSize(BackBMP,bgWidth,bgHeight);

     Height := GetBoxInt(BoxPtr,'LsBoxHeight',bgHeight);
     Width := GetBoxInt(BoxPtr,'LsBoxWidth',bgWidth);

     Buffer := GetBoxString(BoxPtr,'LsBoxDragRect','0 0 0 0');
     DragRGN := CreateRectRgn(Normalize(Str2Int(GetToken(buffer,1)),Width),
                              Normalize(Str2Int(GetToken(buffer,2)),Height),
                              Normalize(Str2Int(GetToken(buffer,3)),Width),
                              Normalize(Str2Int(GetToken(buffer,4)),Height));

     Buffer := BoxReadNextConfig(Box^.BoxPtr,'*LsBoxDragRect');
     While ( Buffer<>'' ) Do
      begin
        tmpRGN := CreateRectRgn(Normalize(Str2Int(GetToken(buffer,1)),Width),
                                Normalize(Str2Int(GetToken(buffer,2)),Height),
                                Normalize(Str2Int(GetToken(buffer,3)),Width),
                                Normalize(Str2Int(GetToken(buffer,4)),Height));
        CombineRgn(dragRGN,dragRGN,tmpRGN,RGN_OR);
        DeleteObject(tmpRGN);
        
        Buffer := BoxReadNextConfig(Box^.BoxPtr,'*LsBoxDragRect');
      end;

     If GetBoxBool(BoxPtr,'LsBoxRememberPosition') then
       SetFlag(Flags,RememberDimensions,True);

//    If GetBoxBool(BoxPtr,'LsBoxNotLayered') then
//       Layerd := false;

     LeftClickBang := GetBoxString(BoxPtr,'LsBoxOnLeftClick','!none');
     RightClickBang := GetBoxString(BoxPtr,'LsBoxOnRightClick','!popup');
   End;

  If NOT GetClassInfo(Inst,'LsBoxClass',wc) then
  Begin
    FillChar(wc,sizeof(wc), #0);
    wc.lpfnWndProc := @WndProc;
    wc.style := CS_HREDRAW or CS_VREDRAW;
    wc.hbrBackground := COLOR_BACKGROUND;
    wc.lpszClassName := 'LsBoxClass';
    wc.hInstance := Inst;
    RegisterClassA(wc);
  End;

  With Box^ do
  Begin
    //create the main Box Window
    if ParentWnd=0 then
     hMainWnd := CreateWindowExA(WS_EX_TOOLWINDOW,
       'LsBoxClass',{PCHAR(Title)}nil,0 or WS_POPUP,
       xPos, yPos, Width, Height, 0, 0,Inst,nil)
    else
     hMainWnd := CreateWindowExA(WS_EX_TOOLWINDOW,
       'LsBoxClass',PCHAR(Title),WS_CHILD,
       xPos, yPos, Width, Height, ParentWnd, 0,Inst,nil);

    Buffer := GetBoxString(BoxPtr,'LsBoxZOrder','NORMAL');
    If UpStr(Buffer)='NORMAL' then
    begin
      SetFlag(Box^.Flags,HugBottom,false);
      SetWindowPos(Box^.hMainWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE+SWP_NOMOVE);
    end else
     If UpStr(Buffer)='STAYONTOP' then
       begin
         SetFlag(Box^.Flags,HugBottom,false);
         SetWindowPos(Box^.hMainWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE+SWP_NOMOVE)
       end else
       If UpStr(Buffer)='HUGBOTTOM' then
        begin
          SetWindowPos(Box^.hMainWnd, LSDskWnd, 0, 0, 0, 0, SWP_NOSIZE+SWP_NOMOVE);
          SetFlag(Box^.Flags,HugBottom,true)
        end else
          begin
            Msgbox(MB_ICONASTERISK,'ZOrder must be either NORMAL, STAYONTOP or HUGBOTTOM');
            SetWindowPos(hMainWnd, HWND_TOP, 0, 0, 0, 0, SWP_NOSIZE+SWP_NOMOVE);
          end;

    If (ParentWnd=0) then
     SetFlag(Flags,isDocked,false)
   else
     SetFlag(Flags,isDocked,true);

    Buffer := GetBoxString(BoxPtr,'LsBoxDockToWindow','PopEl');
    if (Buffer <> 'PopEl')and(ParentWnd=0) then
      if FindWindow(PChar(GetToken(Buffer,1)),PChar(GetToken(Buffer,2)))<>0 then
        begin
        SetWindowLong(hMainWnd, GWL_STYLE, WS_CHILD);
        SetParent(hMainWnd,FindWindow(PChar(GetToken(Buffer,1)),PChar(GetToken(Buffer,2))));
        //disable Fx - it won't work docked to a window anyway
        FxEnabled := false;
        //disable Position saving this won't work right here
        SetFlag(Flags,RememberDimensions,false);
        //normal docking should be disabled too
        //SetFlag(Flags,isDocked,false);
        end else
          MsgBox(MB_ICONWARNING,'Application Window cannot be found!');

    if ( FxEnabled ) then
    begin
      SetWindowLong(hMainWnd, GWL_EXSTYLE, GetWindowLong(hMainWnd, GWL_EXSTYLE)or WS_EX_LAYERED or WS_EX_NOINHERITLAYOUT);

      Buffer := GetBoxString(BoxPtr,'LsBoxUseFX','PopE');
      if (Buffer <> 'PopE')AND(FxEnabled) then
      begin
        FXDelay := Str2Int(GetToken(Buffer,1));
        //FX := AW_HOR_POSITIVE OR AW_VER_POSITIVE;
        FX := 0;
        Buffer := CommandToken(Buffer,2);
        While (Buffer<>'') do
         begin
          FXStr := UpStr(GetToken(Buffer,1));
          if (FXStr='FADE') Then FX := FX OR AW_BLEND
            else if (FXStr='COLLAPSE') Then FX := FX OR AW_CENTER
              else if (FXStr='SLIDE') Then FX := FX OR AW_SLIDE
                else begin
                  if (FXStr='RIGHT') Then FX := FX OR AW_HOR_POSITIVE
                    else if (FXStr='LEFT') Then FX := FX OR AW_HOR_NEGATIVE;
                  if (FXStr='DOWN') Then FX := FX OR AW_VER_POSITIVE
                    else if (FXStr='UP') Then FX := FX OR AW_VER_NEGATIVE;
                end;
            Buffer := CommandToken(Buffer,2);
          end;
          SetFlag(Flags,UseFX,true);
        end;

      Buffer := GetBoxString(BoxPtr,'LsBoxAlphaTransparency','NoPE');
      if ((Buffer <> 'NoPE')AND(Layerd)) then
      begin
        ActTrans := Str2Int(GetToken(buffer,1));
        If GetToken(buffer,2)<>'' then
          InActTrans := Str2Int(GetToken(buffer,2))
        else
          InActTrans := ActTrans;

        If (ActTrans<255)AND(InActTrans<255) then
         begin
           SetLayeredWindowAttributes(hMainWnd, RGB($FF,$00,$FF), ActTrans, LWA_ALPHA or LWA_COLORKEY);
           SetFlag(Flags, AlphaTransparent,true);
         end else
           SetLayeredWindowAttributes(hMainWnd, RGB($FF,$00,$FF), 0, LWA_COLORKEY);
      end else
        if (Layerd) then
          SetLayeredWindowAttributes(hMainWnd, RGB($FF,$00,$FF), 0, LWA_COLORKEY)
        else
          begin
            SetFlag(Flags, AlphaTransparent,false);
            // Region handeling
          end;
    end;

    If NOT GetBoxBool(BoxPtr,'LsBoxNotSticky') then
      SetWindowLong(hMainWnd,GWL_USERDATA,$49474541);

    Box^.Stretched := false;

    Buffer := GetBoxString(BoxPtr,'LsBoxBackgroundOffs','0 0 0 0');
    If ((Buffer<>'0 0 0 0')and(Length(Buffer)>6)) then
     Begin
       //Create the background device context
       Box^.BackDc := CreateCompatibleDC(GetDC(Box^.hMainWnd));
       //And Create The Background from the
       Border.left   := Str2Int(GetToken(Buffer,1));
       Border.Top    := Str2Int(GetToken(Buffer,2));
       Border.Right  := Str2Int(GetToken(Buffer,3));
       Border.Bottom := Str2Int(GetToken(Buffer,4));

       If (Border.left+Border.Right>=Width)then
        begin
          Border.left := 1;
          Border.Right := 1;
          MsgBox(MB_ICONWARNING,'['+Title+']Left or Right Border too wide for given image size!');
        end;

       If (Border.Top+Border.Bottom>=Height)then
        begin
          Border.top := 1;
          Border.bottom := 1;
          MsgBox(MB_ICONWARNING,'['+Title+']Top or Bottom Border too wide for given image size!');
        end;

       BuildBackground(BackBMP, Border.left, Border.Top,
                       Border.Right, Border.Bottom,
                       hMainWnd, BackDc,Width,Height);

       SetFlag(Flags,Resizeable,true);
     End Else Begin
        //Create the background device context
       Box^.BackDc := CreateCompatibleDC(GetDC(Box^.hMainWnd));
       //And Select Te Background Bitmap into it
       SelectObject(Box^.BackDc, BackBMP);
       If ((Height<>bgHeight)OR(Width<>bgWidth)) then
         begin
           Box^.Stretched := true;
           SetFlag(Flags,Resizeable,true);
         end;
     End;

     //handle regions in the main window if not layerd
     If NOT(layerd OR GetFlag(Flags,Resizeable)) then
       begin
         //Get The Background Mask from the BMP
         BackRgn := BitmapToRegion(BackBMP,RGB(255,0,255),$101010,0,0);
         //Then set the Background Mask to the Window
         SetWindowRgn(Box^.hMainWnd,BackRgn,false);
       end;

  End;

  //Free the Bitmap's resources
  If GetFlag(Box^.Flags,Resizeable) Then
    Box^.BackSkin := BackBMP
  else
    DeleteObject(BackBMP);

  Box^.First_Shortcut := nil;
  Box^.First_Module := nil;
  Box^.First_LoadModule := nil;
  Box^.First_WharfModule := nil;
  Box^.First_DockedBox := nil;

  BoxHeader := Box^.BoxPtr;
  Box^.BoxFile := BoxHeader^.FileName;

  BuildShortcuts(Box);
  LoadLoadModules(Box);
  LoadModulesA(Box);
  LoadWharfModules(Box);
  CallModuleHooks(Box);

  If NOT GetBoxBool(Box^.BoxPtr,'LsBoxStartHidden') then
    ShowWindow(Box^.hMainWnd,SW_Show);

  If GetBoxBool(Box^.BoxPtr,'LsBoxAutoHide') then
    SetFlag(Box^.Flags, AutoHide, true);

  InvalidateRect(Box^.hMainWnd,nil,true);

  Buffer := GetBoxString(Box^.BoxPtr,'LsBoxDockTo','noone');
  If NOT ( Buffer='noone' ) then
   begin
     while ( Buffer<>'' ) do
      begin
        if GetBoxFromName(GetToken(Buffer,1))<>nil then
          PostMessage(GetBoxFromName(GetToken(Buffer,1))^.hMainWnd,BM_DOCK,Box^.hMainWnd,(Box^.yPos*$10000)+Box^.xPos);
        Buffer := CommandToken(Buffer,2)
      end;
   end;

  //Close the BoxCfgFile
  Box^.BoxPtr := CloseBox(Box^.BoxPtr,false);

  BuildBox := Box;
End;

Procedure DestroyBox(Box: PBox);
Var
  DockedBox: PDockedBox;
Begin
  With Box^ do
  Begin
    DockedBox := First_DockedBox;
    While (DockedBox<>nil) do
     begin
       First_DockedBox := Dockedbox.Next_DockedBox;
       Dispose(Dockedbox);
       DockedBox := First_DockedBox;
     end;

    DestroyShortcuts(First_Shortcut);
    UnLoadWharfModules(First_WharfModule);
    UnLoadModules(First_Module);
    UnLoadLoadModules(First_LoadModule);

    If GetFlag(Flags,RememberDimensions) Then
    begin
      BoxPtr := OpenBox(BoxFile);
      If ( BoxPtr <> nil ) then
      begin
        SetBoxInt(BoxPtr,'LsBoxX',Box^.xPos);
        SetBoxInt(BoxPtr,'LsBoxY',Box^.yPos);
        BoxPtr := CloseBox(BoxPtr,true);
      end;
    end;

    If GetFlag(Flags,isDocked) then
      SetParent(hMainWnd,0);

    If GetFlag(Flags,Resizeable) Then
      DeleteObject(BackSkin);

    DeleteObject(DragRGN);
    
    DeleteDC(BackDC);

    If Box=First_Box then
      First_Box := Box^.Next_Box
    Else
     begin
       Box^.Prev_Box^.Next_Box := Box^.Next_Box;
       If Box^.Next_Box<>nil then
         Box^.Next_Box^.Prev_Box := Box^.Prev_Box;
     end;

    Dispose (Box);
  End;
End;

End.
