unit Shortcuts;

// Version 1.3
// Removed obsolete RGN_0 VAr
// Fixed the Shortcut Updateing
// Version 1.2
// Shortcutgroups are back - i made them a bit more
// integrated to aid resource security
// Version 1.1
// Removed MergeRgn
// Removed not needed code from SetWindowRgnEx
// Made DestroyShortcuts recursive
// Version 1.0

Interface
Uses
  Windows,
  BoxFiles,
  BoxAPI,
  MyTypes;

Procedure BuildShortcuts(Box:PBox);
Procedure DestroyShortcuts(Shortcut: PShortcut);

Implementation

Function GetShortcutFromClientWnd(Wnd: Integer): Pointer;
Var
  Box : PBox;

  Function Rek(Shortcut: PShortcut; Wnd: Integer): Pointer;
  Begin
    If (Shortcut^.Next_Shortcut = nil) OR (Shortcut^.SWnd = Wnd) then
      Result := Shortcut
    Else
      Result := Rek(Shortcut^.Next_Shortcut, Wnd);
  End;

Begin
  Box := GetBoxFromWnd(First_Box, GetParent(Wnd));
  Result := Rek(Box^.First_ShortCut, Wnd);
end;

Function ClientWndProc(Wnd, Msg: Integer; wParam, lParam: Longint): Longint; stdcall;
Var
  Shortcut : PShortcut;
  Event : TTrackMouseEvent;
  ps : TPaintStruct;
  fHdc : HDC;
  buffer : PChar;

  //procedure UpdateShortcut(ShortCut: PShortcut; DC: HDC; RGN: HRGN);
  procedure UpdateShortcut(ShortCut: PShortcut; newState: TCutState);
  Var newRGN: HRGN;
      newDC: HDC;
  begin
    with Shortcut^ do
     begin
       Case NewState of
         Normal : begin
                    newRGN := RGN_1;
                    newDC  := DC_1;
                  end;
         Over   : begin
                    newRGN := RGN_2;
                    newDC  := DC_2;
                  end;
         Click  : begin
                    newRGN := RGN_3;
                    newDC  := DC_3;
                  end;
       end;

       If newDC=0 then
        begin
          newRGN := RGN_1;
          newDC  := DC_1;
        end;

       DC_0 := newDC;
       SetWindowRgnEx(ShortCut^.Swnd,newRGN);
       InvalidateRGN(ShortCut^.FBox^.hMainWnd,RGN_0,True);
       InvalidateRect(ShortCut^.SWnd,nil,True);
       RGN_0 := newRGN;
       CutState := newState;
     end;
  end;

Begin
  ClientWndProc := 0;
  Shortcut := GetShortcutFromClientWnd(Wnd);
  Case Msg Of
    WM_MOUSEMOVE:
     With Shortcut^ do
       If (CutState=Normal) Then
        Begin
          UpdateShortcut(Shortcut,Over);
          Event.cbSize := Sizeof(TTrackMouseEvent);
          Event.dwFlags := TME_LEAVE;
          Event.hwndTrack := Wnd;
          //SetCursor(LoadCursor(inst,'IDC_ARROW'));
          _TrackMouseEvent(Event);
        End;
    WM_ERASEBKGND:
      BitBlt(wParam,0,0,ShortCut^.Width,ShortCut^.Height,ShortCut^.Dc_0,0,0,SRCCOPY);
    WM_PAINT:
      begin
        fHDC := BeginPaint(Wnd,ps);
        BitBlt(fHDC,0,0,ShortCut^.Width,ShortCut^.Height,ShortCut^.DC_0,0,0,SRCCOPY);
        EndPaint(Wnd,ps);
      end;
    WM_MOUSELEAVE:
     With Shortcut^ do
      if (CutState<>Normal)Then
       Begin
         UpdateShortcut(Shortcut,Normal);
         CutState := Normal;
       End;
  {  WM_WINDOWPOSCHANGING:
     If Not Shortcut^.OnTop then
      begin
        wp := Pointer(lParam);
        wp^.hwndInsertAfter := HWND_BOTTOM;
      end;      }
    WM_LBUTTONDOWN:
         UpdateShortcut(Shortcut,Click);
    WM_LBUTTONUP:
     With Shortcut^ do
       If (CutState=Click) Then
         begin
           UpdateShortcut(Shortcut,Over);
           //Execute Stuff
             PostMessage(Command_HWND,BM_COMMAND,0,Integer(PChar(Shortcut^.Command)));
         end;
    WM_RBUTTONDOWN:
     With Shortcut^ do
       begin
         UpdateShortcut(Shortcut,Click);
       end;
    WM_RBUTTONUP:
     With Shortcut^ do
       If (CutState=Click) Then
         begin
           UpdateShortcut(Shortcut,Over);
           //Execute Stuff
             PostMessage(Command_HWND,BM_COMMAND,0,Integer(PChar(Shortcut^.RCommand)));
         end;
    WM_DROPFILES:
     With Shortcut^ do
      begin
        buffer := StrAlloc(256);
        DragQueryFile(wParam,0,buffer,256);
        //Msgbox(0,buffer);
        LSExecuteEx(GetDesktopWindow, '', Shortcut^.Command, buffer, '',SW_SHOWNORMAL);
        //PostMessage(Command_HWND,BM_COMMAND,0,Integer(PChar(Shortcut^.Command+#32+buffer)));
        StrDispose(buffer);
        DragFinish(wParam);
      end;
    WM_SHOWWINDOW:
     With Shortcut^ do
      begin
        If Floating AND Boolean(wParam) then
          SetWindowPos(SWnd, HWND_TOP, Normalize(xPos,fBox^.Width),
                       Normalize(yPos,fBox^.Height), 0, 0, SWP_NOZORDER+SWP_NOSIZE);
        InvalidateRect(SWnd,nil,true);
      end;
    Else
      ClientWndProc := DefWindowProc(Wnd,msg,wParam,lParam);
  End;
End;

Procedure BuildShortcuts(Box:PBox);
Var
  wc: TWndClass;
  Bitmap_1, Bitmap_2,
  Bitmap_3: HBitmap;
  Buffer, Hint: String;
  ShortCut: PShortcut;
  MainDC: HDC;
  Group: Integer;
  Flags: String;

Begin
  Buffer := BoxReadNextConfig(Box^.BoxPtr,'*Shortcut');
  While ( Buffer<>'' ) Do
    Begin
      New(ShortCut);
      Flags := '';
      Group := 0;
      Shortcut^.Next_Shortcut := Box^.First_Shortcut;
      Box^.First_Shortcut := Shortcut;

      With ShortCut^ Do
      Begin
        fBox := Box;
        Hint := GetToken(Buffer,1);
        xPos := Str2Int(GetToken(buffer,2));
        yPos := Str2Int(GetToken(buffer,3));

        Command := CommandToken(Buffer,7);
        If Command[1]='#' then
        Begin
          Flags := GetToken(Command,1);
          Group := GetGroup(Flags);
          Command := CommandToken(Command,2);
        End;

        If Command[1]='[' then
        Begin
          RCommand := GetTokenEx(Command,'[',']',2);
          Command := GetTokenEx(Command,'[',']',1);
        End else RCommand := '!none';

      End;
      //Build Shortcut Class
      If NOT GetClassInfo(Inst,'LsBoxShortcut',wc) then
      Begin
        FillChar(wc,sizeof(wc), #0);
        wc.lpfnWndProc := @ClientWndProc;
        wc.lpszClassName := 'LsBoxShortcut';
        wc.hInstance := Inst;
        RegisterClassA(wc);
      End;

      With Shortcut^ do
      Begin
        OnTop := Boolean(CheckFlag(Flags,'T'));

        SWnd := CreateWindowExA(
        WS_EX_NOINHERITLAYOUT,'LsBoxShortcut',nil,WS_CHILD,
        xPos,yPos,0,0,Box^.hMainWnd,0,Inst,nil);

        MainDC := GetDC(SWnd);

        Bitmap_1 := LoadLSImage(PChar(GetToken(Buffer,4)),nil);
        If ( Bitmap_1=0 ) then
         begin
          MsgBox(MB_ICONWARNING,'Check Box File: Can''t load first shortcut image:'+#13+GetToken(Buffer,4));
          Box^.First_Shortcut := Next_Shortcut;
          DestroyWindow(SWnd);
          Box^.First_Shortcut := Shortcut^.Next_Shortcut;
          Dispose(Shortcut);
          exit;
        end Else
          Begin
            Rgn_1 := BitmapToRegion(Bitmap_1,RGB(255,0,255),$101010,0,0);
            DC_1 := CreateCompatibleDC(MainDC);
            SelectObject(DC_1, Bitmap_1);
            GetLSBitmapSize(Bitmap_1,Width,Height);
            DeleteObject(Bitmap_1);
          End;

        Bitmap_2 := LoadLSImage(PChar(GetToken(Buffer,5)),nil);
        If ( Bitmap_2=0 ) then
          Begin
            DC_2 := 0;
            RGN_2 := 0
          End Else
          Begin
            Rgn_2 := BitmapToRegion(Bitmap_2,RGB(255,0,255),$101010,0,0);
            DC_2 := CreateCompatibleDC(MainDC);
            SelectObject(DC_2, Bitmap_2);
            DeleteObject(Bitmap_2);
          End;

        Bitmap_3 := LoadLSImage(PChar(GetToken(Buffer,6)),nil);
        If ( Bitmap_3=0 ) then
          Begin
            DC_3 := 0;
            RGN_3 := 0
          End Else
          Begin
            Rgn_3 := BitmapToRegion(Bitmap_3,RGB(255,0,255),$101010,0,0);
            DC_3 := CreateCompatibleDC(MainDC);
            SelectObject(DC_3, Bitmap_3);
            DeleteObject(Bitmap_3);
          End;

        ReleaseDC(Swnd,MainDC);

        GroupItem := AddGroupItem(SWnd,Group);

        DC_0 := DC_1;
        RGN_0 := RGN_1;

        SetWindowRgnEx(SWnd,RGN_0);

        SetWindowPos(SWnd,HWND_BOTTOM,Normalize(xPos,fBox^.Width),Normalize(yPos,fBox^.Height),Width,Height,SWP_HIDEWINDOW);

        If Not(Boolean(CheckFlag(Flags,'H'))or(GetFlag(GroupItem^.Group^.Flags,Hidden))) Then
         begin
           ShowWindow(SWnd,SW_SHOW);
           InvalidateRect(SWnd,nil,true);
         end;

        //Trigger := Boolean(CheckFlag(Flags,'S'));
        DropTarget := Boolean(CheckFlag(Flags,'D'));
        If DropTarget then DragAcceptFiles(SWnd, DropTarget);


        CreateHint(Swnd,PChar(Hint));

        Floating := Boolean(CheckFlag(Flags,'F'));

        CutState := Normal;
      End;

      Buffer := BoxReadNextConfig(Box^.BoxPtr,'*Shortcut');
    End;

End;

Procedure DestroyShortcuts(Shortcut: PShortcut);
Begin
 If ( Shortcut<>nil ) then
  With Shortcut^ Do
  Begin
    RemoveHint(SWnd);
    If ( Rgn_3<>Rgn_1 ) then
      DeleteObject(Rgn_3);
    If ( Rgn_2<>Rgn_1 ) then
      DeleteObject(Rgn_2);
    If ( Rgn_1<>0 ) then
      DeleteObject(Rgn_1);
    If ( DC_3<>DC_1 ) then
      DeleteDC(DC_3);
    If ( DC_2<>DC_1 ) then
      DeleteDC(DC_2);
    If ( DC_1<>0 ) then
      DeleteDC(DC_1);

    if (GroupItem^.Prev_Item = nil) then
     begin
      GroupItem^.Group^.First_Item := GroupItem^.Next_Item;
      if (GroupItem^.Next_Item <> nil) then
        GroupItem^.Next_Item^.Prev_Item := nil;
     end else
       if (GroupItem^.Next_Item = nil) then
         GroupItem^.Prev_Item^.Next_Item := nil
       else
        begin
          GroupItem^.Next_Item^.Prev_Item := GroupItem^.Prev_Item;
          GroupItem^.Prev_Item^.Next_Item := GroupItem^.Next_Item;
        end;
    Dispose(GroupItem);

    DestroyWindow(SWnd);
    DestroyShortcuts (Next_Shortcut);
    Dispose (Shortcut);
  end;
End;


Begin

End.